﻿Imports System.Data
Imports System.Data.SqlClient

Public Class Form1
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        Me.PopulateComboBox()
        Me.PopulateDataGridView()
    End Sub

    Private Sub cbCountries_SelectionChangeCommitted(sender As System.Object, e As System.EventArgs) Handles cbCountries.SelectionChangeCommitted
        Me.PopulateDataGridView()
    End Sub

    Private Sub PopulateComboBox()
        Dim query As String = "SELECT DISTINCT Country FROM Customers"
        Dim constr As String = "Data Source=.\SQL2005;Initial Catalog=Northwind;User ID=sa;Password=pass@123"
        Using con As SqlConnection = New SqlConnection(constr)
            Using sda As SqlDataAdapter = New SqlDataAdapter(query, con)
                'Fill the DataTable with records from Table.
                Dim dt As DataTable = New DataTable()
                sda.Fill(dt)

                'Insert the Default Item to DataTable.
                Dim row As DataRow = dt.NewRow()
                row(0) = ""
                dt.Rows.InsertAt(row, 0)

                'Assign DataTable as DataSource.
                cbCountries.DataSource = dt
                cbCountries.DisplayMember = "Country"
                cbCountries.ValueMember = "Country"
            End Using
        End Using
    End Sub

    Private Sub PopulateDataGridView()
        Dim query As String = "SELECT CustomerID, ContactName, Country FROM Customers"
        query &= " WHERE Country = @Country"
        query &= " OR ISNULL(@Country, '') = ''"
        Dim constr As String = "Data Source=.\SQL2005;Initial Catalog=Northwind;User ID=sa;Password=pass@123"
        Using con As SqlConnection = New SqlConnection(constr)
            Using cmd As SqlCommand = New SqlCommand(query, con)
                cmd.Parameters.AddWithValue("@Country", cbCountries.SelectedValue)
                Using sda As SqlDataAdapter = New SqlDataAdapter(cmd)
                    Dim dt As DataTable = New DataTable()
                    sda.Fill(dt)
                    dataGridView1.DataSource = dt
                End Using
            End Using
        End Using
    End Sub
End Class
